local info, addon = ...

addon.STRINGS = {
	ADDON_LOADED = {
		English = "Ensemble (v{1}) loaded."
	},
	ITEM_NOT_FOUND = {
		English = "Item \"{1}\" was not found, keeping current item."
	},
	UNKNOWN_NOT_FOUND = {
		English = "An item for slot \"{1}\" could not be found, keeping current item."
	},
	EQUIP_ERROR = {
		English = "Error while equipping item \"{1}\"."
	},
	UNKNOWN_EQUIP_ERROR = {
		English = "Error while equipping item into slot \"{1}\"."
	},
	SUBSET_REMOVED = {
		English = "Subset removed."
	},
	ROLE_LINKED = {
		English = "Role linked to role {1}."
	},
	INVALID_ROLE_LINKED = {
		English = "Unable to link to an inexistant role."
	},
	ROLE_RESET = {
		English = "Role reset and unlinked."
	},
	PROFILE_WIPED = {
		English = "Current profile wiped."
	},
	EVERYTHING_WIPED = {
		English = "Everything wiped."
	}
}

function addon.L( id, ... )
	local lng = Inspect.System.Language()

	if type( id ) == "table" then return id[lng] or id.English end

	if not addon.STRINGS[id] then error( "invalid localization token " .. tostring( id ) ) end

	local token = addon.STRINGS[id][lng] or addon.STRINGS[id].English
	local replacements = { ... }

	local replacer = function( i ) return replacements[tonumber(i)] end

	return (token:gsub( "{(%d+)}", replacer ))
end
