local info, lib = ...

Library = Library or {}
Library.Slash = lib

function lib.Register( tbl )
	local addon = Inspect.Addon.Detail( Inspect.Addon.Current() )
	addon.data["/"] = tbl

	table.insert( Command.Slash.Register( addon.id ), {
		function( line )
			lib.Handler( addon, line )
		end,
		addon.id,
		"/" .. addon.id
	} )
	table.insert( Command.Slash.Register( addon.toc.NameShort ), {
		function( line )
			lib.Handler( addon, line )
		end,
		addon.id,
		"/" .. addon.toc.NameShort
	} )
end

function lib.PrintHelp( addon )
	print( "Usage: /" .. addon.id:lower() .. " or /" .. addon.toc.NameShort:lower() )

	local tmp = {}
	for k, v in pairs( addon.data["/"] ) do
		table.insert( tmp, k )
	end
	table.sort( tmp )

	for _, k in pairs( tmp ) do
		local v = addon.data["/"][k]
		print( "", k .. (v.syntax == "" and "" or (" " .. v.syntax)) .. ": " .. v.help )
	end
end

function lib.Handler( addon, line )
	local parts = {}
	for chunk in line:gmatch( "%S+" ) do
		table.insert( parts, chunk )
	end

	local cmd = table.remove( parts, 1 )
	local hnd = addon.data["/"][cmd]

	if cmd == "help" or not hnd then
		lib.PrintHelp( addon )
		return
	end

	if hnd.func then
		hnd.func( table.concat( parts, " " ), unpack( parts ) )
	end
end
